Debian Bug report logs - #344759
screen mishandles xterm control string to set window title

version graph

Package: screen; Maintainer for screen is Axel Beckert <abe@debian.org>; Source for screen is src:screen.

Reported by: dickey@his.com

Date: Sun, 25 Dec 2005 17:48:02 UTC

Severity: normal

Tags: fixed-upstream

Found in versions screen/4.0.2-4.1, screen/4.0.3-7

Fixed in version screen/4.1.0~20110819git450e8f3-1

Done: Axel Beckert <abe@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Adam Lazur <zal@debian.org>:
Bug#344759; Package screen. Full text and rfc822 format available.

Acknowledgement sent to dickey@his.com:
New Bug report received and forwarded. Copy sent to Adam Lazur <zal@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Thomas Dickey <tom@invisible-island.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: screen mishandles xterm control string to set window title
Date: Sun, 25 Dec 2005 12:41:50 -0500
Package: screen
Version: 4.0.2-4.1
Severity: normal


screen's so-called "rxvt_osc" option (actually xterm control sequences)
includes handling for OSC parameters 0 and 1.  Referring to ctlseqs.ms,
these parameters are of interest:

                 Ps = 0  -> Change Icon Name and Window Title to Pt
                 Ps = 1  -> Change Icon Name to Pt
                 Ps = 2  -> Change Window Title to Pt

screen allows 0 and 1 (it should allow 2, but it is not used as often,
and screen's code is unpalatable).  However, it maps the 0 into 1,
setting only the icon name.  That isn't useful and is opposite to the
normal sense these control sequences would be used in.  It's a one-line
fix to address that (see below).

Also while I'm here, adding a comment to misc.c to note that I fixed a problem
in ncurses long ago (screen's maintainers declined to acknowledge that).

# ------------------------------------------------------------------------------
# display.c |    2 +-
# misc.c    |   13 +++++++++++++
# 2 files changed, 14 insertions(+), 1 deletion(-)
# ------------------------------------------------------------------------------
Index: display.c
--- screen-4.0.2/display.c	2003-12-05 13:45:41.000000000 +0000
+++ screen-4.0.2-20051225/display.c	2005-12-25 16:43:26.000000000 +0000
@@ -3053,7 +3053,7 @@
 int i;
 char *s;
 {
-  static char oscs[] = "1;\000\00020;\00039;\00049;\000";
+  static char oscs[] = "0;\000\00020;\00039;\00049;\000";
 
   ASSERT(display);
   if (!D_CXT)
Index: misc.c
--- screen-4.0.2/misc.c	2003-12-05 13:45:41.000000000 +0000
+++ screen-4.0.2-20051225/misc.c	2005-12-25 17:19:43.000000000 +0000
@@ -652,6 +652,19 @@
  * zeros but sleeps instead. This breaks CalcCost, of course.
  * Also, the ncurses wait functions use a global variable
  * to store the current outc function. Oh well...
+ *
+ * This comment dates from late 1998.  See ncurses NEWS (990102):
+ *
+ *	+ provide support for termcap ospeed variable by copying it from the
+ *	  internal cur_term member, and using ospeed as the baudrate reference
+ *	  for the delay_output and tputs functions.  If an application does not
+ *	  set ospeed, the library behaves as before, except that _nc_timed_wait
+ *	  is no longer used, or needed, since ospeed always has a value.  But
+ *	  the application can modify ospeed to adjust the output of padding
+ *	  characters (from a bug report for screen 3.7.6 and email from Michael
+ *	  Schroeder <Michael.Schroeder@informatik.uni-erlangen.de>).
+ *
+ * Also read the source code for delay_output() -TD
  */
 
 int (*save_outc) __P((int));

-- System Information:
Debian Release: testing/unstable
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.4.27-td2
Locale: LANG=C, LC_CTYPE=C (charmap=ANSI_X3.4-1968)

Versions of packages screen depends on:
ii  base-passwd                   3.5.10     Debian base system master password
ii  debconf                       1.4.65     Debian configuration management sy
ii  libc6                         2.3.5-8    GNU C Library: Shared libraries an
ii  libncursesw5                  5.5-1      Shared libraries for terminal hand
ii  libpam0g                      0.79-3     Pluggable Authentication Modules l
ii  passwd                        1:4.0.13-7 change and administer password and

screen recommends no packages.

-- debconf information:
  screen/old_upgrade_prompt: false



Bug marked as found in version 4.0.3-7. Request was from Craig Sanders <cas@taz.net.au> to control@bugs.debian.org. (Fri, 18 Apr 2008 10:51:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Jan Christoph Nordholz <hesso@pool.math.tu-berlin.de>:
Bug#344759; Package screen. Full text and rfc822 format available.

Acknowledgement sent to Craig Sanders <cas@taz.net.au>:
Extra info received and forwarded to list. Copy sent to Jan Christoph Nordholz <hesso@pool.math.tu-berlin.de>.

Your message did not contain a Subject field. They are recommended and useful because the title of a $gBug is determined using this field. Please remember to include a Subject field in your messages in future.

Full text and rfc822 format available.


Message #12 received at 344759@bugs.debian.org (full text, mbox):

From: Craig Sanders <cas@taz.net.au>
To: 344759@bugs.debian.org
Date: Fri, 18 Apr 2008 21:19:59 +1000
This bug is particularly annoying when using screen from within a tabbed
terminal emulator (i do this frequently...ssh into a remote host, with
the tab title set to the host's name, then run screen), because it
doesn't just change the tab title, it also changes the icon-title.

this causes the Gnome panel applet, Window List, to display mrxvt's name
as whatever the current screen "window" title is.

to demonstrate:

1. run X, with gnome, and make sure you have a panel with the Window
List applet running in it.

2. start up mrxvt, a nice tabbed terminal.

3. open several new tabs.  change the titles on them.  the tab titles
will change but mrxvt's name in Window List remains unchanged.

4. start screen.

5. change the title of the current screen window.  watch in amazement
as it changes not only the tab title but also mrxvt's name in Window
List.   

6. create more windows in screen and do the same.  see it change
both tab and icon title as you switch between screen windows.

7. click on another tab in mrxvt.  the icon title stays exactly the same
as what screen set it to.

8. try changing the title of a tab in mrxvt.  the tab changes title OK,
but the icon title (i.e. in Window List) doesn't.  in other words,
you can't fix the title from mrxvt.

9. try a program such as xttitle to change the title.  it will also
change both the tab title and the icon title.  success!

10. actually, no...just failure! change back to the screen tab in mrxvt,
and then change to another window in screen. it screws up your icon
title again.

there is no fix, because screen is doing the wrong thing every time you
switch to another window in screen. it should set only the window title
with ESC]2, and not the icon title with ESC]0

obviously, there's some element of personal preference and personal
working environment here. 

the ultimate fix that should satisfy everyone is that screen should be
configurable so that the user can choose whether screen sets the window
title, the icon title, neither, or both. i honestly don't care what the
default setting it - leave it as it currently is so the change doesn't
surprise anyone. i'd be happy to edit my .screenrc if only there was an
option to edit.


please forward this bug report upstream.  it should contain enough
detail to describe what the problem is and why it's happening, and
hopefully come up with a fix.


craig

-- 
craig sanders <cas@taz.net.au>




Added tag(s) fixed-upstream. Request was from Sadrul Habib Chowdhury <imadil@gmail.com> to control@bugs.debian.org. (Wed, 11 Nov 2009 16:18:08 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Axel Beckert <abe@debian.org> to control@bugs.debian.org. (Sat, 08 Oct 2011 22:00:02 GMT) Full text and rfc822 format available.

Reply sent to Axel Beckert <abe@debian.org>:
You have taken responsibility. (Sun, 09 Oct 2011 02:54:10 GMT) Full text and rfc822 format available.

Notification sent to dickey@his.com:
Bug acknowledged by developer. (Sun, 09 Oct 2011 02:54:10 GMT) Full text and rfc822 format available.

Message #21 received at 344759-close@bugs.debian.org (full text, mbox):

From: Axel Beckert <abe@debian.org>
To: 344759-close@bugs.debian.org
Subject: Bug#344759: fixed in screen 4.1.0~20110819git450e8f3-1
Date: Sun, 09 Oct 2011 02:50:41 +0000
Source: screen
Source-Version: 4.1.0~20110819git450e8f3-1

We believe that the bug you reported is fixed in the latest version of
screen, which is due to be installed in the Debian FTP archive:

screen_4.1.0~20110819git450e8f3-1.debian.tar.gz
  to main/s/screen/screen_4.1.0~20110819git450e8f3-1.debian.tar.gz
screen_4.1.0~20110819git450e8f3-1.dsc
  to main/s/screen/screen_4.1.0~20110819git450e8f3-1.dsc
screen_4.1.0~20110819git450e8f3-1_i386.deb
  to main/s/screen/screen_4.1.0~20110819git450e8f3-1_i386.deb
screen_4.1.0~20110819git450e8f3.orig.tar.gz
  to main/s/screen/screen_4.1.0~20110819git450e8f3.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 344759@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Axel Beckert <abe@debian.org> (supplier of updated screen package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 09 Oct 2011 03:29:31 +0200
Source: screen
Binary: screen
Architecture: source i386
Version: 4.1.0~20110819git450e8f3-1
Distribution: experimental
Urgency: low
Maintainer: Jan Christoph Nordholz <hesso@pool.math.tu-berlin.de>
Changed-By: Axel Beckert <abe@debian.org>
Description: 
 screen     - terminal multiplexor with VT100/ANSI terminal emulation
Closes: 25096 152961 176626 223320 344759 353090 361274 450421 461107 481411 488619 496750 532240 541793 558724 560231 578729 591624 603009 612990 621704 630535 641867
Changes: 
 screen (4.1.0~20110819git450e8f3-1) experimental; urgency=low
 .
   [ Brian P Kroth ]
   * New upstream snapshot based on 4.1.0 prerelease 20101110git066b098 as
     packaged by Fedora 15 (Closes: #641867)
   * Removed the following patches which have been applied upstream or are
     otherwise no more necessary:
     - 01CVS
     - 02configure_use_ncursesw
     - 03fully_expand_screenencodings
     - 09CHERRY_*
     - 15manpage_typos
     - 16fix_gcc_warnings_II
     - 18manpage_maxwin_limit
     - 19flowcontrol_lockup
     - 20defmonitor
     - 21manpage_nethack_activation
     - 25allow_symlink_sockdir
     - 27doc_sty_noenvpassing
     - 28blankerprg_callsemantics
     - 29infodoc_version
     - 31upstream_cherries
     - 33increase_max_winmsg_renditions
     - 35screen_invoked_with_a_command
     - 40cjk_eastasian
     - 50EXP_tilde_expansion
   * Refreshed the following patches:
     - 10norootpassword
     - 14size_matters
     - 26source_encoding
   * Added patches from Fedora:
     - 47screen-cc: Additional assertions to improve stability
     - 48screen-ipv6: IPv6 support for built-in telnet
   * Enable telnet (Closes: #353090) and localized day/month names
 .
   [ Axel Beckert ]
   * Add myself as Uploader.
   * Remove Adam Lazur from Uploaders. (Closes: #603009)
   * New upstream snapshot based on 4.1.0 prerelease, commit 450e8f3 of
     2011-Aug-19. (LP: #183849)
     - Fixes a crash when attaching to a layout that was created while
       detached. (Closes: #591624, LP: #786292, #788670)
     - Raises MAXWIN to 100 (Closes: #450421)
     - No more segfaults if resized to 0 or 1 line tall (Closes: #532240,
       LP: #315237)
     - screen -d -m no more segfaults on setenv without value (Closes: #496750)
     - Now has tsl, fsl and dsl terminfo caps (Closes: #152961)
     - Windows created with "-d -m" no more ignore "-X exec" (Closes: #481411)
     - Now has a session name string escape (Closes: #488619)
     - Re-optimize screen updates (Closes: #621704, LP: #588846)
     - No more mishandles xterm control string to set window title (Closes:
       #344759) Thanks to Thomas Dickey and Sadrul Habib Chowdhury.
     - Fixes/Relaxes requirement for a controlling terminal (Closes: #461107)
     - Uses fuzzy-matching for session names only if required (Closes: #361274)
     - Has customizable digraphs (Closes: #25096, a wishlist bug from 1998! :-)
     - Fixes a bug with displaying blank spaces with bce on. (Closes: #578729,
       LP: #702094)
     - Fix using alternate screen buffers in some cases. (Closes: #558724)
     - Several fixes for handling mouse events. (Closes: #223320)
   * Remove the patches which have been applied upstream or are
     otherwise no more necessary:
     - 17manpage_sessionname_warning
     - 30fix_fsf_address
   * Refreshed the following patches:
     - 10norootpassword
     - 11replace_doc_paths
     - 12kfreebsd_ctty
     - 14size_matters
     - 16fix_gcc_warnings
     - 22exchange_file_mode
     - 23exitcode_q_ls
     - 24option_parser
     - 32misc_minor_fixes
   * Refreshed and renumbered the following patches:
     - {51 => 80}EXP_session_creation_time
   * Added patches:
     - 46fix-keybinding-typo-in-manpage (Closes: #630535, #541793)
     - 49long-usernames (Closes: #560231, LP: #582153)
     - 50increase-max-TERM-length
   * Use dh_autoreconf
     - Build-Depend on dh-autoreconf
   * Convert to source format "3.0 (quilt)"
     - Remove build dependency on dpatch
   * Bump Standards-Version to 3.9.2 (no changes)
   * Update debian/copyright
     - Upstream switched to GPLv3
     - Update debian packaging information
   * Fix lintian warning debian-rules-missing-recommended-target
   * Add lintian override for
     possibly-insecure-handling-of-tmp-files-in-maintainer-script
   * /etc/init.d/screen-cleanup: check for existence of screen binary
     (Closes: #612990)
   * Add Vcs-* headers
   * Add extend-diff-ignore=config\.h\.in to debian/source/options
   * Added a NEWS file stating problems to attach to a detached 4.0.3
     session with a 4.1.0 screen, e.g. during a dist-upgrade
   * Suggest iselect, screenie or byobu (Closes: #176626)
Checksums-Sha1: 
 7ec9f8b888ba0ffe73a7c5095462f67c6bc5c369 1435 screen_4.1.0~20110819git450e8f3-1.dsc
 80bd40a8cdeef29f9531e850bed0ac93216849aa 785431 screen_4.1.0~20110819git450e8f3.orig.tar.gz
 ca7e8ee2661693ab9f21b818d14d1302062d0c0a 41056 screen_4.1.0~20110819git450e8f3-1.debian.tar.gz
 9994caaa295088d0928ac5d16f32af426bbc9501 648474 screen_4.1.0~20110819git450e8f3-1_i386.deb
Checksums-Sha256: 
 ba8e3350885321def274b4997c37d94f069ef57da3ef88f9bd9e15be636b4572 1435 screen_4.1.0~20110819git450e8f3-1.dsc
 2c3aa30b8dfab0ac7bf741d7903da7d3d052e1762a17866cf816269049589c69 785431 screen_4.1.0~20110819git450e8f3.orig.tar.gz
 98de79fdb01d68d94935ae3f0a813eff41dfab463edd6fc4891e81cc288e1193 41056 screen_4.1.0~20110819git450e8f3-1.debian.tar.gz
 a415f990fe18c4660866cbb21764b5677dfd8109f419b3742fc155a65d573128 648474 screen_4.1.0~20110819git450e8f3-1_i386.deb
Files: 
 d2e18660ea8a8ce180857b773a416493 1435 misc optional screen_4.1.0~20110819git450e8f3-1.dsc
 287eb1b39047adffc3445ff43ac9db65 785431 misc optional screen_4.1.0~20110819git450e8f3.orig.tar.gz
 d5bdb5cebfc3c070ea7fef4bf9ed9689 41056 misc optional screen_4.1.0~20110819git450e8f3-1.debian.tar.gz
 385df6e38a116881b3d56ec84c750f9c 648474 misc optional screen_4.1.0~20110819git450e8f3-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk6RAVsACgkQwJ4diZWTDt50TQCeLu7Qwq0KAH0YYGXfgIU2VKmu
LXIAn0lsyrdOpA2sqLX11NlhobKVuVrH
=0eo1
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 11 Jul 2012 07:45:23 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 08:10:06 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.